package orchid.gui;

import orchid.object.*;
import orchid.agent.*;
import com.objectspace.voyager.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.border.Border;
import javax.swing.BorderFactory;
import javax.swing.border.TitledBorder;

/**
 * @author Marc-Aurle DARCHE
 */
public class AnswerWindow extends JFrame {

	String server;
	String username;
	Point meetingAgentWindowLocation;
	Point answerWindowLocation;
	MeetingProposal mp;
	
	public AnswerWindow(String identString, Point meetingAgentWindowLocation) {
		super("Answer Window");
		this.server= Util.getServer();
		this.meetingAgentWindowLocation=meetingAgentWindowLocation;
		if ( (identString.length()>0) && (identString.indexOf("_")>0) ) this.username=identString.substring(0,identString.indexOf("_"));
		else username=identString;
	}

	public void init(){

		this.setBackground(new Color(255,255,255));

		JTextField initiator_Field = new JTextField(20);
		TitledBorder titledBorder0 = BorderFactory.createTitledBorder("Initiator of meeting");
		JPanel initiator_Panel = new JPanel();
		initiator_Panel.setLayout(new FlowLayout());
		initiator_Panel.add(initiator_Field);
		initiator_Panel.setBorder(titledBorder0);
		
		JTextField subject_Field = new JTextField(20);
		TitledBorder titledBorder1 = BorderFactory.createTitledBorder("Subject of meeting");
		JPanel subject_Panel = new JPanel();
		subject_Panel.setLayout(new FlowLayout());
		subject_Panel.add(subject_Field);
		subject_Panel.setBorder(titledBorder1);

		TitledBorder titledBorder2 = BorderFactory.createTitledBorder("Notes");
		Border emptyBorder2 = BorderFactory.createEmptyBorder(10, 10, 10, 10);
		Border compoundBorder2 = BorderFactory.createCompoundBorder(titledBorder2,emptyBorder2);
		JTextArea notes_Area= new JTextArea(8,20);
		notes_Area.setBorder(BorderFactory.createEmptyBorder(4,4,4,4));
		JScrollPane notes_Pane = new JScrollPane(notes_Area);
		notes_Pane.setPreferredSize(new Dimension(350, 200));
		notes_Pane.setMinimumSize(new Dimension(350, 200));
		notes_Pane.setBorder(compoundBorder2);
		
		JLabel duration_Label = new JLabel("Duration :");
		JTextField duration_Field = new JTextField(10);
		JTextField startDate_Field = new JTextField(10);
		JLabel startDate_Label = new JLabel("Between :");
		JTextField endDate_Field = new JTextField(10);
		JLabel endDate_Label = new JLabel("And :");
	
		JPanel duration_Panel = new JPanel();
		duration_Panel.setLayout(new FlowLayout());
		JPanel startDate_Panel = new JPanel();
		startDate_Panel.setLayout(new FlowLayout());
		JPanel aroundfield_Pane = new JPanel();
		JPanel field_Pane = new JPanel();
		field_Pane.setLayout(new GridLayout(3,2));
		field_Pane.add(duration_Label);
		field_Pane.add(duration_Field);
		field_Pane.add(startDate_Label);
		field_Pane.add(startDate_Field);
		field_Pane.add(endDate_Label);
		field_Pane.add(endDate_Field);
		aroundfield_Pane.add(field_Pane);

		ParticipantsTableModel myModel = new ParticipantsTableModel();
		JTable table = new JTable(myModel);
		table.setPreferredScrollableViewportSize(new Dimension(300, 100));
		JScrollPane scrollPane = new JScrollPane(table, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

		JPanel main_Panel= new JPanel();
		main_Panel.setLayout(new BoxLayout(main_Panel, BoxLayout.Y_AXIS));
				
		JButton yes_Button= new JButton("Yes");
		yes_Button.setMnemonic('y');
		yes_Button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) { 
				try{
					IMeetingAgent ma = (IMeetingAgent) Namespace.lookup("//"+server+"/ma__");
				} catch (Exception ve) { System.err.println(ve); }
					destroy();
		Util.logMsg("info","AnswerWindow","answer Yes sent via //"+server+"/ma__"+username);
			}
		});
		JButton no_Button= new JButton("No");
		no_Button.setMnemonic('n');
		no_Button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) { 
				try{
					IMeetingAgent ma = (IMeetingAgent) Namespace.lookup("//"+server+"/ma__");
				} catch (Exception ve) { System.err.println(ve); }
					destroy();
		Util.logMsg("info","AnswerWindow","answer No sent via //"+server+"/ma__"+username);
			}
		});
		JPanel buttonPane2 = new JPanel();
		JLabel anwserText= new JLabel("Will you come ? ");
		buttonPane2.add(anwserText);
		buttonPane2.add(yes_Button);
		buttonPane2.add(no_Button);

		main_Panel.add(initiator_Panel);
		main_Panel.add(subject_Panel);
		main_Panel.add(notes_Pane);
		main_Panel.add(aroundfield_Pane);
	
		Border raisedbevel = BorderFactory.createRaisedBevelBorder();
		JPanel inside = new JPanel();
		inside.setBorder(raisedbevel);
		inside.setLayout(new BoxLayout(inside, BoxLayout.Y_AXIS));
		inside.add(main_Panel, BorderLayout.NORTH);
		inside.add(Box.createRigidArea(new Dimension(0, 20)));

		inside.add(scrollPane, BorderLayout.CENTER);
		inside.add(buttonPane2, BorderLayout.SOUTH);

		Container c = getContentPane();
		c.add(inside);
	}
	
	public void start(){
		this.pack();
		answerWindowLocation= new Point();
		answerWindowLocation.setLocation(meetingAgentWindowLocation);
		answerWindowLocation.translate(10,100);
		this.setLocation(answerWindowLocation);
		this.setVisible(true);
	}

	public void destroy(){
		this.dispose();
	}

	static public void main (String args[]){
		Point p= new Point();
		AnswerWindow aw= new AnswerWindow("dummyuser",p);
		aw.init();
		aw.start();
	}
}
