package orchid.gui;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.BorderFactory;
import javax.swing.border.TitledBorder;

/**
 * @author Marc-Aurle DARCHE
 */
public class ButtonBarWindow extends JFrame {

	String identString;
	Point buttonBarWindowLocation;
	Point loginWindowLocation;
		
	public ButtonBarWindow(String identString, Point loginWindowLocation) {
		super("custom bar");
		this.identString=identString;
		this.loginWindowLocation=loginWindowLocation;
	}
	
	public void init(){
		JPanel main_Panel= new JPanel();
		main_Panel.setLayout(new GridLayout(4,1));
		Border raisedbevel = BorderFactory.createRaisedBevelBorder();
		main_Panel.setBorder(raisedbevel);
				
		JButton meeting_Button= new JButton("Meeting Agent");
		meeting_Button.setToolTipText("To the meeting Agent");
		meeting_Button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) { 
				MeetingAgentWindow maw= new MeetingAgentWindow(identString,buttonBarWindowLocation);
				maw.init();
				maw.start();
			}
		});

    JButton search_Button= new JButton("Search Agent");
		search_Button.setToolTipText("To the search Agent");

    JButton conf_Button= new JButton("Configuration");
		conf_Button.setToolTipText("To the advanced configuration panel");

                JButton close_Button= new JButton("Close application");
		close_Button.setToolTipText("Click here to quit ORCHID");
		close_Button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.exit(0);
			}
		});

		main_Panel.add(meeting_Button);
		main_Panel.add(search_Button);
		main_Panel.add(conf_Button);
		main_Panel.add(close_Button);
		getContentPane().add(main_Panel);
	}

	public void start(){
		this.pack();
		buttonBarWindowLocation= new Point();
		buttonBarWindowLocation.setLocation(loginWindowLocation);
		this.setLocation(buttonBarWindowLocation);
		this.setVisible(true);
		// to get getLocationOnScreen() the component has first to be visible !
		this.addComponentListener(new ComponentAdapter() {
			public void componentMoved(ComponentEvent e){
				buttonBarWindowLocation.setLocation(getLocationOnScreen());
			}
		});
	}

	public void destroy(){
		this.dispose();
	}

}

