package orchid.gui;

import orchid.object.*;
import orchid.agent.*;
import com.objectspace.voyager.*;

import java.util.Hashtable;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.border.Border;
import javax.swing.BorderFactory;
import javax.swing.border.TitledBorder;

/**
 * @author Marc-Aurle DARCHE & Frdric SALVY
 */
public class CallMeetingWindow extends JFrame {

	String server;
	String username;
	Point meetingAgentWindowLocation;
	Point callMeetingWindowLocation;
	MeetingProposal mp;
	Hashtable guestlist=new Hashtable();
	boolean essential=false;
	
	JTextField subject_Field;
	JTextField duration_Field;
	JTextField startDate_Field;
	JTextField endDate_Field;
	JTextArea notes_Area;
	JTable table;
	JLabel status_Label;
	
	public CallMeetingWindow(String identString, Point meetingAgentWindowLocation) {
		super("Call Meeting Window");
		this.server= Util.getServer();
		this.meetingAgentWindowLocation=meetingAgentWindowLocation;
		if ( (identString.length()>0) && (identString.indexOf("_")>0) ) this.username=identString.substring(0,identString.indexOf("_"));
		else username=identString;
	}

	public void init(){
		subject_Field = new JTextField(20);
		JLabel duration_Label = new JLabel("Duration :");
		duration_Field = new JTextField(10);
		startDate_Field = new JTextField(10);
		JLabel startDate_Label = new JLabel("Between :");
		endDate_Field = new JTextField(10);
		JLabel endDate_Label = new JLabel("And :");
		status_Label= new JLabel("                    ");
		status_Label.setForeground(new Color(200,0,10));
		JPanel status_Pane = new JPanel();
		status_Pane.add(status_Label);
		
		duration_Field.setText("100");
		Calculation calDayTime= new Calculation();
		String sDay=Integer.toString(calDayTime.getTodayDay());
		String sMonth=Integer.toString(calDayTime.getTodayMonth());
		String sYear=Integer.toString(calDayTime.getTodayYear());
	
		startDate_Field.setText(sDay+"/"+sMonth+"/"+sYear);
		endDate_Field.setText(sDay+"/"+sMonth+"/"+sYear);
		TitledBorder titledBorder1 = BorderFactory.createTitledBorder("Enter the Subject of meeting");

		ParticipantsTableModel myModel = new ParticipantsTableModel();
		table = new JTable(myModel);
		table.setPreferredScrollableViewportSize(new Dimension(300, 100));
		JScrollPane scrollPane = new JScrollPane(table, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
 
		JPanel subject_Panel = new JPanel();
		subject_Panel.setLayout(new FlowLayout());
		subject_Panel.add(subject_Field);
		subject_Panel.setBorder(titledBorder1);
		
		JPanel duration_Panel = new JPanel();
		duration_Panel.setLayout(new FlowLayout());
		JPanel startDate_Panel = new JPanel();
		startDate_Panel.setLayout(new FlowLayout());
		JPanel aroundfield_Pane = new JPanel();
		JPanel field_Pane = new JPanel();
		field_Pane.setLayout(new GridLayout(3,2));
		field_Pane.add(duration_Label);
		field_Pane.add(duration_Field);
		field_Pane.add(startDate_Label);
		field_Pane.add(startDate_Field);
		field_Pane.add(endDate_Label);
		field_Pane.add(endDate_Field);
		aroundfield_Pane.add(field_Pane);

		TitledBorder titledBorder2 = BorderFactory.createTitledBorder("Enter Notes here");
		Border emptyBorder2 = BorderFactory.createEmptyBorder(10, 10, 10, 10);
		Border compoundBorder2 = BorderFactory.createCompoundBorder(titledBorder2,emptyBorder2);
		notes_Area= new JTextArea(8,20);
		notes_Area.setBorder(BorderFactory.createEmptyBorder(4,4,4,4));
		JScrollPane notes_Pane = new JScrollPane(notes_Area);
		notes_Pane.setPreferredSize(new Dimension(350, 200));
		notes_Pane.setMinimumSize(new Dimension(350, 200));
		notes_Pane.setBorder(compoundBorder2);
		
		JPanel main_Panel= new JPanel();
		main_Panel.setLayout(new BoxLayout(main_Panel, BoxLayout.Y_AXIS));
				
		JButton newUser_Button= new JButton("Invite another User");
		newUser_Button.setMnemonic('n');
		newUser_Button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) { 
				boolean vint = orchid.object.Util.validateInteger(duration_Field.getText());
				boolean vdate = orchid.object.Util.validateDate(startDate_Field.getText());
				boolean vdate2 = orchid.object.Util.validateDate(endDate_Field.getText());
				if ( !vint || !vdate || !vdate2)
					status_Label.setText("You entered invalid parameters !");
				else
					status_Label.setText("Congratulations, valid parameters");
			}
		});

		getRootPane().setDefaultButton(newUser_Button);
		JPanel buttonPane1 = new JPanel();
		buttonPane1.add(newUser_Button);

		JButton send_Button= new JButton("Send the Call");
		send_Button.setMnemonic('s');
		send_Button.setToolTipText("Click here when done");
		send_Button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) { 
				boolean vint = orchid.object.Util.validateInteger(duration_Field.getText());
				boolean vdate = orchid.object.Util.validateDate(startDate_Field.getText());
				boolean vdate2 = orchid.object.Util.validateDate(endDate_Field.getText());
				if ( !vint || !vdate || !vdate2)
					status_Label.setText("You entered invalid parameters !");
				else {
					status_Label.setText("Congratulations, valid parameters");
					String chaine=" "; int nbligne=0;
					guestlist=new Hashtable();
					guestlist.put( username, new GuestInfo(username,true) );
					for (int ligne=0;ligne<table.getRowCount();ligne++) {
					  chaine=table.getValueAt(ligne,0).toString();
					  System.out.println("chaine "+chaine);
					  if ( chaine.length()>0 ) {
						nbligne++;
						if ( ((Boolean)table.getValueAt(ligne,1)).booleanValue() ) essential=true;
						else essential=false;
						guestlist.put( (String)table.getValueAt(ligne,0), new GuestInfo( (String)table.getValueAt(ligne,0),essential));
					  }
					}

					int timeout=1;
					mp= new MeetingProposal(subject_Field.getText(),notes_Area.getText(),username,1999,01,01,1999,02,01,new Integer(duration_Field.getText()).intValue(),guestlist,timeout);
					try {
					  IMeetingAgent ma = (IMeetingAgent) Namespace.lookup("//"+server+"/ma__"+username);
					  ma.callMeeting(mp);
					} catch (Exception ve) { System.err.println(ve); }
					destroy();
					Util.logMsg("info","CallMeetingWindow","call meeting sent via //"+server+"/ma__"+username);
				}// end of else (valid parameters)
			}
		});

		JPanel buttonPane2 = new JPanel();
		buttonPane2.add(send_Button);

		main_Panel.add(subject_Panel);
		main_Panel.add(notes_Pane);
		main_Panel.add(aroundfield_Pane);

		Border raisedbevel = BorderFactory.createRaisedBevelBorder();
		JPanel inside = new JPanel();
		inside.setBorder(raisedbevel);
		inside.setLayout(new BoxLayout(inside, BoxLayout.Y_AXIS));
		inside.add(main_Panel, BorderLayout.NORTH);
		inside.add(Box.createRigidArea(new Dimension(0, 20)));
		inside.add(status_Pane);
		inside.add(Box.createRigidArea(new Dimension(0, 20)));
		inside.add(buttonPane1);
		inside.add(scrollPane, BorderLayout.CENTER);
		inside.add(buttonPane2, BorderLayout.SOUTH);

		Container c = getContentPane();
		c.add(inside);
	}

	public void start(){
	  this.pack();
	  callMeetingWindowLocation= new Point();
	  callMeetingWindowLocation.setLocation(meetingAgentWindowLocation);
	  callMeetingWindowLocation.translate(10,100);
	  this.setLocation(callMeetingWindowLocation);
	  this.setVisible(true);
	}

	public void destroy(){
	  this.dispose();
	}

	static public void main (String args[]){
	  Point p= new Point();
	  CallMeetingWindow cmw= new CallMeetingWindow("dummyUser",p);
	  cmw.init();
	  cmw.start();
	}
}
